import de.joethei.hs.java2.praktikum1.GrosseZahl;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.function.Executable;

import static org.junit.jupiter.api.Assertions.*;

class GrosseZahlTest {

    @Test
    void constructors() {
        Executable exec = () -> new GrosseZahl("Hallo Welt");
        assertThrows(NumberFormatException.class, exec);
        assertEquals(new GrosseZahl("1456"), new GrosseZahl(1456));
        assertNotEquals(new GrosseZahl("1234"), new GrosseZahl(1233));
    }

    @Test
    void add() {
        assertEquals(new GrosseZahl(42), new GrosseZahl("40").add(new GrosseZahl(2)));
        assertEquals(new GrosseZahl("42"), new GrosseZahl(40).add(new GrosseZahl(2)));
        assertNotEquals(new GrosseZahl(43), new GrosseZahl("40").add(new GrosseZahl(2)));
    }

    @Test
    void sub() {
        assertEquals(new GrosseZahl(42), new GrosseZahl(100).sub(new GrosseZahl(58)));
        assertNotEquals(new GrosseZahl(43), new GrosseZahl(100).sub(new GrosseZahl(58)));
    }

    @Test
    void mult() {
        assertEquals(new GrosseZahl(15), new GrosseZahl("5").mult(new GrosseZahl(3)));
        assertNotEquals(new GrosseZahl("15"), new GrosseZahl("4").mult(new GrosseZahl(3)));
        assertEquals(new GrosseZahl(90000), new GrosseZahl(9).mult(new GrosseZahl(10000)));
    }

    @Test
    void less() {
        assertTrue(new GrosseZahl("1234").less(new GrosseZahl("12345")));
        assertFalse(new GrosseZahl("12345").less(new GrosseZahl("1234")));
        assertFalse(new GrosseZahl("1234").less(new GrosseZahl("1234")));
        assertFalse(new GrosseZahl("1234").less(new GrosseZahl("1233")));
    }

    @Test
    void ggT() {
        assertEquals(new GrosseZahl(3), new GrosseZahl(45).ggT(new GrosseZahl(21)));
        assertEquals(new GrosseZahl(70), new GrosseZahl(1400).ggT(new GrosseZahl(210)));
        assertNotEquals(new GrosseZahl(2), new GrosseZahl("7").ggT(new GrosseZahl(13)));
    }

}